import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * A table to put cards on.
 * 
 * @author Michael Berry
 * @version 23/04/09
 */
public class Table extends World
{

    private Deck deck;

    /**
     * Create a new table
     */
    public Table()
    {    
        super(600, 400, 1);
        deck = new Deck(Card.Colour.BLUE, true, 1, 1, 1, 1);
        addObject(deck, 40, 50);
        reset();
    }
    
    /**
     * If the deck is clicked on, then draw a card from it (unless it's empty.)
     */
    public void act()
    {
        if(Greenfoot.mouseClicked(deck) && deck.getSize()>0) {
            Card c = deck.drawCard();
            addObject(c, Greenfoot.getRandomNumber(getWidth()), Greenfoot.getRandomNumber(getHeight()));
        }
        if(Greenfoot.isKeyDown("space")) {
            reset();
        }
    }
    
    /**
     * Fill the deck and get rid of cards on the table.
     */
    private void reset()
    {
        for(Actor a : (List<Actor>)getObjects(null)) {
            if(! (a instanceof Deck)) {
                removeObject(a);
            }
        }
        deck.fill();
        deck.shuffle();
        Greenfoot.start();
    }
}
